﻿// --------------------------------------------------------------------------------------------
// Stefan Cruysberghs
// http://www.scip.be
// Article: Customize WCF RIA Services code generation
// http://www.scip.be/index.php?Page=ArticlesNET36
// --------------------------------------------------------------------------------------------
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Navigation;
using System.Windows.Shapes;
using ScipBe.Demo.RiaCodeGen.Web.Domain;
using ScipBe.Demo.RiaCodeGen.Web.Services;
using System.ServiceModel.DomainServices.Client;
using System.Diagnostics;

namespace ScipBe.Demo.RiaCodeGen
{
    public partial class Home : Page
    {
        public Home()
        {
            InitializeComponent();
        }

        // Executes when the user navigates to this page.
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            var context = new ProductContext();

            context.Load(context.GetProductsQuery());

            context.Load(
                context.GetProductsByNameQuery("ton"),
                LoadBehavior.MergeIntoCurrent,
                loadOperation =>
                {
                    var products = context.Products;
                    var loadedEntities = loadOperation.Entities;
                }, null);
        }

        private void Button2_Click(object sender, RoutedEventArgs e)
        {
            var context = new ProductContext();

            Action<LoadOperation> callBack =
                loadOperation =>
                {
                    var error = loadOperation.Error;
                    if (error != null)
                    {
                        Debugger.Break();
                    }

                    var products = context.Products;
                };

            context.Load(context.GetProductsQuery(), callBack);

            if (!WebContext.Current.IsBusy)
            {
                Debugger.Break();
            }
        }
    }
}